> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pinkfish.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# langbase-pipes

> Langbase Pipes - manage and run AI pipe agents

**Server path:** `/langbase-pipes` | **Type:** Application | **PCID required:** Yes

## Tools

| Tool                                                              | Description                                          |
| ----------------------------------------------------------------- | ---------------------------------------------------- |
| [`langbase_pipes_create_message`](#langbase_pipes_create_message) | POST /v1/threads/\{threadId}/messages                |
| [`langbase_pipes_create_pipe`](#langbase_pipes_create_pipe)       | POST /v1/pipes                                       |
| [`langbase_pipes_create_thread`](#langbase_pipes_create_thread)   | POST /v1/threads                                     |
| [`langbase_pipes_delete_message`](#langbase_pipes_delete_message) | DELETE /v1/threads/\{threadId}/messages/\{messageId} |
| [`langbase_pipes_delete_thread`](#langbase_pipes_delete_thread)   | DELETE /v1/threads/\{threadId}                       |
| [`langbase_pipes_get_models`](#langbase_pipes_get_models)         | GET /v1/models                                       |
| [`langbase_pipes_get_pipe`](#langbase_pipes_get_pipe)             | GET /v1/pipes/\{ownerLogin}/\{pipeName}              |
| [`langbase_pipes_get_thread`](#langbase_pipes_get_thread)         | GET /v1/threads/\{threadId}                          |
| [`langbase_pipes_list_messages`](#langbase_pipes_list_messages)   | GET /v1/threads/\{threadId}/messages                 |
| [`langbase_pipes_list_pipes`](#langbase_pipes_list_pipes)         | GET /v1/pipes                                        |
| [`langbase_pipes_run_agent`](#langbase_pipes_run_agent)           | POST /v1/agent/run                                   |
| [`langbase_pipes_run_pipe`](#langbase_pipes_run_pipe)             | POST /v1/pipes/run                                   |
| [`langbase_pipes_update_message`](#langbase_pipes_update_message) | POST /v1/threads/\{threadId}/messages/\{messageId}   |
| [`langbase_pipes_update_pipe`](#langbase_pipes_update_pipe)       | POST /v1/pipes/\{pipeName}                           |
| [`langbase_pipes_update_thread`](#langbase_pipes_update_thread)   | POST /v1/threads/\{threadId}                         |

***

## langbase\_pipes\_create\_message

POST /v1/threads/\{threadId}/messages

**Parameters:**

| Parameter  | Type      | Required | Default | Description                            |
| ---------- | --------- | -------- | ------- | -------------------------------------- |
| `threadId` | string    | Yes      | —       | Thread Id                              |
| `body`     | object\[] | Yes      | —       | Array of messages to add to the thread |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      },
      "body": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "role": {
              "type": "string",
              "enum": [
                "user",
                "assistant",
                "tool"
              ],
              "description": "The role of the message author"
            },
            "content": {
              "type": "string",
              "description": "The text content of the message"
            },
            "tool_call_id": {
              "type": "string",
              "description": "ID for tool call responses"
            },
            "name": {
              "type": "string",
              "description": "Tool name for tool messages"
            }
          },
          "required": [
            "role",
            "content"
          ]
        },
        "description": "Array of messages to add to the thread"
      }
    },
    "required": [
      "PCID",
      "threadId",
      "body"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_create\_pipe

POST /v1/pipes

**Parameters:**

| Parameter             | Type      | Required | Default | Description           |
| --------------------- | --------- | -------- | ------- | --------------------- |
| `description`         | string    | No       | —       | The description value |
| `frequency_penalty`   | number    | No       | —       | Frequency Penalty     |
| `json`                | boolean   | No       | —       | The json value        |
| `max_tokens`          | number    | No       | —       | Max Tokens            |
| `memory`              | object\[] | No       | —       | The memory value      |
| `messages`            | object\[] | No       | —       | The messages value    |
| `model`               | string    | No       | —       | The model value       |
| `moderate`            | boolean   | No       | —       | The moderate value    |
| `name`                | string    | Yes      | —       | The name value        |
| `parallel_tool_calls` | boolean   | No       | —       | Parallel Tool Calls   |
| `presence_penalty`    | number    | No       | —       | Presence Penalty      |
| `status`              | string    | No       | —       | The status value      |
| `stop`                | string\[] | No       | —       | The stop value        |
| `store`               | boolean   | No       | —       | The store value       |
| `stream`              | boolean   | No       | —       | The stream value      |
| `temperature`         | number    | No       | —       | The temperature value |
| `tool_choice`         | object    | No       | —       | Tool Choice           |
| `tools`               | object    | No       | —       | The tools value       |
| `top_p`               | number    | No       | —       | Top P                 |
| `type`                | string    | No       | —       | The type value        |
| `upsert`              | boolean   | No       | —       | The upsert value      |
| `variables`           | object\[] | No       | —       | The variables value   |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "description": {
        "type": "string",
        "description": "The description value"
      },
      "frequency_penalty": {
        "type": "number",
        "description": "Frequency Penalty"
      },
      "json": {
        "type": "boolean",
        "description": "The json value"
      },
      "max_tokens": {
        "type": "number",
        "description": "Max Tokens"
      },
      "memory": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "string",
              "description": "The name value"
            }
          },
          "required": [
            "name"
          ]
        },
        "description": "The memory value"
      },
      "messages": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "role": {
              "type": "string",
              "enum": [
                "user",
                "system",
                "function",
                "assistant"
              ],
              "description": "The role value"
            },
            "name": {
              "type": "string",
              "description": "The name value"
            },
            "content": {
              "type": "string",
              "description": "The content value"
            }
          },
          "required": [
            "role",
            "content"
          ]
        },
        "description": "The messages value"
      },
      "model": {
        "type": "string",
        "description": "The model value"
      },
      "moderate": {
        "type": "boolean",
        "description": "The moderate value"
      },
      "name": {
        "type": "string",
        "description": "The name value"
      },
      "parallel_tool_calls": {
        "type": "boolean",
        "description": "Parallel Tool Calls"
      },
      "presence_penalty": {
        "type": "number",
        "description": "Presence Penalty"
      },
      "status": {
        "type": "string",
        "description": "The status value",
        "enum": [
          "private",
          "public"
        ]
      },
      "stop": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "The stop value"
      },
      "store": {
        "type": "boolean",
        "description": "The store value"
      },
      "stream": {
        "type": "boolean",
        "description": "The stream value"
      },
      "temperature": {
        "type": "number",
        "description": "The temperature value"
      },
      "tool_choice": {
        "description": "Tool Choice"
      },
      "tools": {
        "description": "The tools value"
      },
      "top_p": {
        "type": "number",
        "description": "Top P"
      },
      "type": {
        "type": "string",
        "description": "The type value",
        "enum": [
          "chat",
          "generate"
        ]
      },
      "upsert": {
        "type": "boolean",
        "description": "The upsert value"
      },
      "variables": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "string",
              "description": "The name value"
            },
            "value": {
              "type": "string",
              "description": "The value value"
            }
          },
          "required": [
            "name",
            "value"
          ]
        },
        "description": "The variables value"
      }
    },
    "required": [
      "PCID",
      "name"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_create\_thread

POST /v1/threads

**Parameters:**

| Parameter  | Type   | Required | Default | Description                      |
| ---------- | ------ | -------- | ------- | -------------------------------- |
| `metadata` | object | No       | —       | Optional metadata for the thread |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "metadata": {
        "type": "object",
        "description": "Optional metadata for the thread"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_delete\_message

DELETE /v1/threads/\{threadId}/messages/\{messageId}

**Parameters:**

| Parameter   | Type   | Required | Default | Description |
| ----------- | ------ | -------- | ------- | ----------- |
| `threadId`  | string | Yes      | —       | Thread Id   |
| `messageId` | string | Yes      | —       | Message Id  |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      },
      "messageId": {
        "type": "string",
        "description": "Message Id"
      }
    },
    "required": [
      "PCID",
      "threadId",
      "messageId"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_delete\_thread

DELETE /v1/threads/\{threadId}

**Parameters:**

| Parameter  | Type   | Required | Default | Description |
| ---------- | ------ | -------- | ------- | ----------- |
| `threadId` | string | Yes      | —       | Thread Id   |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      }
    },
    "required": [
      "PCID",
      "threadId"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_get\_models

GET /v1/models

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_get\_pipe

GET /v1/pipes/\{ownerLogin}/\{pipeName}

**Parameters:**

| Parameter    | Type   | Required | Default | Description |
| ------------ | ------ | -------- | ------- | ----------- |
| `ownerLogin` | string | Yes      | —       | Owner Login |
| `pipeName`   | string | Yes      | —       | Pipe Name   |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "ownerLogin": {
        "type": "string",
        "description": "Owner Login"
      },
      "pipeName": {
        "type": "string",
        "description": "Pipe Name"
      }
    },
    "required": [
      "PCID",
      "ownerLogin",
      "pipeName"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_get\_thread

GET /v1/threads/\{threadId}

**Parameters:**

| Parameter  | Type   | Required | Default | Description |
| ---------- | ------ | -------- | ------- | ----------- |
| `threadId` | string | Yes      | —       | Thread Id   |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      }
    },
    "required": [
      "PCID",
      "threadId"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_list\_messages

GET /v1/threads/\{threadId}/messages

**Parameters:**

| Parameter  | Type   | Required | Default | Description |
| ---------- | ------ | -------- | ------- | ----------- |
| `threadId` | string | Yes      | —       | Thread Id   |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      }
    },
    "required": [
      "PCID",
      "threadId"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_list\_pipes

GET /v1/pipes

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      }
    },
    "required": [
      "PCID"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_run\_agent

POST /v1/agent/run

**Parameters:**

| Parameter   | Type      | Required | Default | Description                                               |
| ----------- | --------- | -------- | ------- | --------------------------------------------------------- |
| `messages`  | object\[] | Yes      | —       | An array of message objects to run through the agent      |
| `threadId`  | string    | No       | —       | Identifier for continuing an existing conversation thread |
| `variables` | object    | No       | —       | Variables for dynamic prompt customization                |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "messages": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "role": {
              "type": "string",
              "enum": [
                "system",
                "user",
                "assistant",
                "tool"
              ],
              "description": "The role of the message author"
            },
            "content": {
              "type": "string",
              "description": "The content of the message"
            }
          },
          "required": [
            "role",
            "content"
          ]
        },
        "description": "An array of message objects to run through the agent"
      },
      "threadId": {
        "type": "string",
        "description": "Identifier for continuing an existing conversation thread"
      },
      "variables": {
        "type": "object",
        "description": "Variables for dynamic prompt customization"
      }
    },
    "required": [
      "PCID",
      "messages"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_run\_pipe

POST /v1/pipes/run

**Parameters:**

| Parameter   | Type      | Required | Default | Description                                                      |
| ----------- | --------- | -------- | ------- | ---------------------------------------------------------------- |
| `memory`    | object\[] | No       | —       | Memory objects to use, overriding the pipe's configured memories |
| `messages`  | object\[] | Yes      | —       | An array of message objects to run through the pipe              |
| `threadId`  | string    | No       | —       | Identifier for continuing an existing conversation thread        |
| `variables` | object    | No       | —       | Variables for dynamic prompt customization                       |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "memory": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "string",
              "description": "Memory set name"
            }
          }
        },
        "description": "Memory objects to use, overriding the pipe's configured memories"
      },
      "messages": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "role": {
              "type": "string",
              "enum": [
                "system",
                "user",
                "assistant",
                "tool"
              ],
              "description": "The role of the message author"
            },
            "content": {
              "type": "string",
              "description": "The content of the message"
            },
            "tool_call_id": {
              "type": "string",
              "description": "ID for tool responses"
            },
            "name": {
              "type": "string",
              "description": "Tool name for tool messages"
            }
          },
          "required": [
            "role",
            "content"
          ]
        },
        "description": "An array of message objects to run through the pipe"
      },
      "threadId": {
        "type": "string",
        "description": "Identifier for continuing an existing conversation thread"
      },
      "variables": {
        "type": "object",
        "description": "Variables for dynamic prompt customization"
      }
    },
    "required": [
      "PCID",
      "messages"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_update\_message

POST /v1/threads/\{threadId}/messages/\{messageId}

**Parameters:**

| Parameter   | Type   | Required | Default | Description                     |
| ----------- | ------ | -------- | ------- | ------------------------------- |
| `threadId`  | string | Yes      | —       | Thread Id                       |
| `messageId` | string | Yes      | —       | The ID of the message to update |
| `content`   | string | No       | —       | The content value               |
| `metadata`  | object | No       | —       | The metadata value              |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      },
      "messageId": {
        "type": "string",
        "description": "The ID of the message to update"
      },
      "content": {
        "type": "string",
        "description": "The content value"
      },
      "metadata": {
        "type": "object",
        "description": "The metadata value"
      }
    },
    "required": [
      "PCID",
      "threadId",
      "messageId"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_update\_pipe

POST /v1/pipes/\{pipeName}

**Parameters:**

| Parameter             | Type      | Required | Default | Description           |
| --------------------- | --------- | -------- | ------- | --------------------- |
| `pipeName`            | string    | Yes      | —       | Pipe Name             |
| `description`         | string    | No       | —       | The description value |
| `frequency_penalty`   | number    | No       | —       | Frequency Penalty     |
| `json`                | boolean   | No       | —       | The json value        |
| `max_tokens`          | number    | No       | —       | Max Tokens            |
| `memory`              | object\[] | No       | —       | The memory value      |
| `messages`            | object\[] | No       | —       | The messages value    |
| `model`               | string    | No       | —       | The model value       |
| `moderate`            | boolean   | No       | —       | The moderate value    |
| `name`                | string    | No       | —       | The name value        |
| `parallel_tool_calls` | boolean   | No       | —       | Parallel Tool Calls   |
| `presence_penalty`    | number    | No       | —       | Presence Penalty      |
| `regenerateApiKey`    | boolean   | No       | —       | Regenerate Api Key    |
| `status`              | string    | No       | —       | The status value      |
| `stop`                | string\[] | No       | —       | The stop value        |
| `store`               | boolean   | No       | —       | The store value       |
| `stream`              | boolean   | No       | —       | The stream value      |
| `temperature`         | number    | No       | —       | The temperature value |
| `tool_choice`         | object    | No       | —       | Tool Choice           |
| `tools`               | object    | No       | —       | The tools value       |
| `top_p`               | number    | No       | —       | Top P                 |
| `variables`           | object\[] | No       | —       | The variables value   |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "pipeName": {
        "type": "string",
        "description": "Pipe Name"
      },
      "description": {
        "type": "string",
        "description": "The description value"
      },
      "frequency_penalty": {
        "type": "number",
        "description": "Frequency Penalty"
      },
      "json": {
        "type": "boolean",
        "description": "The json value"
      },
      "max_tokens": {
        "type": "number",
        "description": "Max Tokens"
      },
      "memory": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "string",
              "description": "The name value"
            }
          },
          "required": [
            "name"
          ]
        },
        "description": "The memory value"
      },
      "messages": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "role": {
              "type": "string",
              "enum": [
                "user",
                "system",
                "function",
                "assistant"
              ],
              "description": "The role value"
            },
            "name": {
              "type": "string",
              "description": "The name value"
            },
            "content": {
              "type": "string",
              "description": "The content value"
            }
          },
          "required": [
            "role",
            "content"
          ]
        },
        "description": "The messages value"
      },
      "model": {
        "type": "string",
        "description": "The model value"
      },
      "moderate": {
        "type": "boolean",
        "description": "The moderate value"
      },
      "name": {
        "type": "string",
        "description": "The name value"
      },
      "parallel_tool_calls": {
        "type": "boolean",
        "description": "Parallel Tool Calls"
      },
      "presence_penalty": {
        "type": "number",
        "description": "Presence Penalty"
      },
      "regenerateApiKey": {
        "type": "boolean",
        "description": "Regenerate Api Key"
      },
      "status": {
        "type": "string",
        "description": "The status value",
        "enum": [
          "private",
          "public"
        ]
      },
      "stop": {
        "type": "array",
        "items": {
          "type": "string"
        },
        "description": "The stop value"
      },
      "store": {
        "type": "boolean",
        "description": "The store value"
      },
      "stream": {
        "type": "boolean",
        "description": "The stream value"
      },
      "temperature": {
        "type": "number",
        "description": "The temperature value"
      },
      "tool_choice": {
        "description": "Tool Choice"
      },
      "tools": {
        "description": "The tools value"
      },
      "top_p": {
        "type": "number",
        "description": "Top P"
      },
      "variables": {
        "type": "array",
        "items": {
          "type": "object",
          "properties": {
            "name": {
              "type": "string",
              "description": "The name value"
            },
            "value": {
              "type": "string",
              "description": "The value value"
            }
          },
          "required": [
            "name",
            "value"
          ]
        },
        "description": "The variables value"
      }
    },
    "required": [
      "PCID",
      "pipeName"
    ]
  }
  ```
</Expandable>

***

## langbase\_pipes\_update\_thread

POST /v1/threads/\{threadId}

**Parameters:**

| Parameter  | Type   | Required | Default | Description        |
| ---------- | ------ | -------- | ------- | ------------------ |
| `threadId` | string | Yes      | —       | Thread Id          |
| `metadata` | object | No       | —       | The metadata value |

<Expandable title="inputSchema">
  ```json theme={null}
  {
    "type": "object",
    "properties": {
      "PCID": {
        "type": "string",
        "description": "Pink Connect ID for the authenticated connection"
      },
      "threadId": {
        "type": "string",
        "description": "Thread Id"
      },
      "metadata": {
        "type": "object",
        "description": "The metadata value"
      }
    },
    "required": [
      "PCID",
      "threadId"
    ]
  }
  ```
</Expandable>
